300. Longest Increasing Subsequence
Given an unsorted array of integers, find the length of longest increasing subsequence.
For example,
Given [10, 9, 2, 5, 3, 7, 101, 18]
,
The longest increasing subsequence is [2, 3, 7, 101]
, therefore the length is 4
. Note that there may be more than one LIS combination, it is only necessary for you to return the length.
Your algorithm should run in O(n2) complexity.
Follow up: Could you improve it to O(n log n) time complexity?
class Solution {
public:
//leetcode 300最长递增子数列,O(nlogn)方法,使用递归+二分查找
int lengthOfLIS(vector<int>& nums) {
int n=nums.size();
if(n==0) return 0;
vector<int> dp(n,0);
vector<int> ends(n,0);
ends[0]=nums[0];
int left=0;//左
int right=0;//保存上次的最右边
int mid=0;
dp[0]=1;
int r=0;//右
int maxres=1;
for(int i=1;i<n;i++){
left=0;
r=right;
while(left<=r)
{
mid=left+(r-left)/2;
if(nums[i]>ends[mid])
{
left=mid+1;
}
else r=mid-1;
}
right=max(right,left);
ends[left]=nums[i];
dp[i]=left+1;
maxres=max(dp[i],maxres);
}
return maxres;
}
};